package tree;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.io.IOException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.border.BevelBorder;

import netscape.javascript.JSObject;

import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

import br.gov.mma.Node;

public class HTApplet extends Applet implements ActionListener {
	
	public HTApplet()
    {
        ntNos = 0;
        undoControlAtual = 0;
        undoControlBase = 0;
        curDir = "";
        pathRoot = null;
    }

    protected Button makebutton(String s, GridBagLayout gridbaglayout, GridBagConstraints gridbagconstraints, Panel panel1, String s1)
    {
        Button button = new Button(s);
        gridbaglayout.setConstraints(button, gridbagconstraints);
        panel1.add(button);
        return button;
    }

    protected void makeLabel(String s, GridBagLayout gridbaglayout, GridBagConstraints gridbagconstraints, double d)
    {
        gridbagconstraints.weightx = 0.5D;
        textLabel = new Label(s);
        textLabel.setFont(new Font("Serif", 0, 12));
        textLabel.setForeground(Color.black);
        textLabel.setBackground(Color.lightGray);
        gridbaglayout.setConstraints(textLabel, gridbagconstraints);
        add(textLabel);
        gridbagconstraints.weightx = d;
        textField = new TextField(16);
        textField.setFont(new Font("Serif", 0, 12));
        textField.setBackground(Color.lightGray);
        gridbaglayout.setConstraints(textField, gridbagconstraints);
        add(textField);
    }
    
    protected void makeMenuBar(JFrame jframe)
    {
    	/**
    	 * Foi modificado para apresentar apenas o campo para busca do termo desejado,
    	 * Nao permitindo ao usuario modificar a arvore atraves dos comandos disponibilizados
    	 * pelo projeto.
    	 */
        menubar = new JMenuBar();
        menubar.setBorder(new BevelBorder(0));
        HTToolBar httoolbar = new HTToolBar(view);
        httoolbar.addSeparator();
        httoolbar.addSeparator();
        Label label = new Label("Busca:", 2);
        label.setFont(new Font("Serif", 0, 12));
        httoolbar.add(label);
        TextField textfield = new TextField(8);
        textfield.setFont(new Font("Serif", 0, 12));
        view.setSearchField(textfield);
        textfield.addTextListener(new HTListenerText(view));
        textfield.addFocusListener(new FocusListener(){

			public void focusGained(FocusEvent arg0) {
				HTAction.focusBusca = true;
			}

			public void focusLost(FocusEvent arg0) {
				HTAction.focusBusca = false;
			}
        	
        });
        
        httoolbar.add(textfield);
        /*Insets insets = new Insets(2, 15, 18, 15);
        httoolbar.setMargin(insets);*/
        menubar.add(httoolbar);
    }

    protected void makeLabelR(String s, GridBagLayout gridbaglayout, GridBagConstraints gridbagconstraints, double d)
    {
        gridbagconstraints.weightx = 0.5D;
        textLabel = new Label(s);
        textLabel.setFont(new Font("Serif", 0, 12));
        textLabel.setForeground(Color.black);
        textLabel.setBackground(Color.lightGray);
        view.setTextLabel(textLabel);
        gridbaglayout.setConstraints(textLabel, gridbagconstraints);
        add(textLabel);
        gridbagconstraints.weightx = d;
        gridbagconstraints.gridwidth = 0;
        textField = new TextField(16);
        textField.setFont(new Font("Serif", 0, 12));
        textField.setBackground(Color.lightGray);
        gridbaglayout.setConstraints(textField, gridbagconstraints);
        add(textField);
    }

    protected void makeInterfaceEditor(JFrame jframe)
    {
        GridBagLayout gridbaglayout = new GridBagLayout();
        GridBagConstraints gridbagconstraints = new GridBagConstraints();
        Panel panel1 = new Panel();
        panel1.setSize(new Dimension(jframe.getWidth(), 128));
        panel1.setLayout(gridbaglayout);
        panel1.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        view.setPanel(panel1);
        panel1.setVisible(false);
        jframe.getContentPane().add(panel1);
        gridbagconstraints.weightx = 0.0D;
        gridbagconstraints.insets = new Insets(4, 0, 4, 0);
        gridbagconstraints.anchor = 13;
        textLabel = new Label("Nome:", 2);
        textLabel.setFont(new Font("Serif", 0, 12));
        textLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        if(htBackColorEdit.trim().equals("0x000000"))
            textLabel.setForeground(Color.white);
        else
            textLabel.setForeground(Color.black);
        view.setTextLabel(textLabel);
        gridbaglayout.setConstraints(textLabel, gridbagconstraints);
        panel1.add(textLabel);
        textField = new TextField(16);
        textField.setFont(new Font("Serif", 0, 12));
        textField.setBackground(Color.lightGray);
        view.setTextField(textField);
        gridbaglayout.setConstraints(textField, gridbagconstraints);
        panel1.add(textField);
        gridbagconstraints.anchor = 13;
        corLabel = new Label("  Cor:", 2);
        corLabel.setFont(new Font("Serif", 0, 12));
        corLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        if(htBackColorEdit.trim().equals("0x000000"))
            corLabel.setForeground(Color.white);
        else
            corLabel.setForeground(Color.black);
        view.setCorLabel(corLabel);
        gridbaglayout.setConstraints(corLabel, gridbagconstraints);
        panel1.add(corLabel);
        gridbagconstraints.anchor = 10;
        corField = new TextField(8);
        corField.setFont(new Font("Serif", 0, 12));
        corField.setBackground(Color.lightGray);
        view.setCorField(corField);
        gridbaglayout.setConstraints(corField, gridbagconstraints);
        panel1.add(corField);
        corField.setEnabled(true);
        view.setCorF(makebutton("...", gridbaglayout, gridbagconstraints, panel1, "Definir a cor do n\363."));
        view.setAplicarF(makebutton("Aplicar aos Filhos", gridbaglayout, gridbagconstraints, panel1, "Aplicar a cor escolhida a todos os filhos do n\363 selecionado."));
        corTextLabel = new Label("  Cor Texto:", 2);
        corTextLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        if(htBackColorEdit.trim().equals("0x000000"))
            corTextLabel.setForeground(Color.white);
        else
            corTextLabel.setForeground(Color.black);
        view.setCorTextLabel(corTextLabel);
        gridbaglayout.setConstraints(corTextLabel, gridbagconstraints);
        panel1.add(corTextLabel);
        gridbagconstraints.anchor = 10;
        corText = new TextField(8);
        corText.setFont(new Font("Serif", 0, 12));
        corText.setBackground(Color.lightGray);
        view.setCorText(corText);
        gridbaglayout.setConstraints(corText, gridbagconstraints);
        panel1.add(corText);
        corText.setEnabled(true);
        view.setCorT(makebutton("...", gridbaglayout, gridbagconstraints, panel1, "Definir a cor do texto."));
        view.setAplicarT(makebutton("Aplicar aos Filhos", gridbaglayout, gridbagconstraints, panel1, "Aplicar a cor escolhida a todos os filhos do n\363 selecionado."));
        gridbagconstraints.gridwidth = 0;
        Label label = new Label(" ");
        label.setFont(new Font("Serif", 0, 12));
        label.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        view.setCorTextLabel(label);
        gridbaglayout.setConstraints(label, gridbagconstraints);
        panel1.add(label);
        gridbagconstraints.gridwidth = 1;
        hintLabel = new Label(" Hint: ");
        hintLabel.setFont(new Font("Serif", 0, 12));
        hintLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        if(htBackColorEdit.trim().equals("0x000000"))
            hintLabel.setForeground(Color.white);
        else
            hintLabel.setForeground(Color.black);
        view.setHintLabel(hintLabel);
        gridbaglayout.setConstraints(hintLabel, gridbagconstraints);
        panel1.add(hintLabel);
        gridbagconstraints.gridwidth = 0;
        hintField = new TextField(90);
        hintField.setFont(new Font("Serif", 0, 12));
        hintField.setBackground(Color.lightGray);
        view.setHintField(hintField);
        gridbaglayout.setConstraints(hintField, gridbagconstraints);
        panel1.add(hintField);
        gridbagconstraints.gridwidth = 1;
        urlLabel = new Label(" URL: ");
        urlLabel.setFont(new Font("Serif", 0, 12));
        urlLabel.setBackground(new Color(Color.decode(htBackColorEdit).getRGB()));
        if(htBackColorEdit.trim().equals("0x000000"))
            urlLabel.setForeground(Color.white);
        else
            urlLabel.setForeground(Color.black);
        view.setURLLabel(urlLabel);
        gridbaglayout.setConstraints(urlLabel, gridbagconstraints);
        panel1.add(urlLabel);
        gridbagconstraints.gridwidth = 0;
        urlField = new TextField(90);
        urlField.setFont(new Font("Serif", 0, 12));
        urlField.setBackground(Color.lightGray);
        view.setURLField(urlField);
        gridbaglayout.setConstraints(urlField, gridbagconstraints);
        panel1.add(urlField);
        gridbagconstraints.anchor = 10;
        gridbagconstraints.ipady = 12;
        gridbagconstraints.ipadx = 12;
        gridbagconstraints.gridwidth = 4;
        view.setOk(makebutton("   OK   ", gridbaglayout, gridbagconstraints, panel1, "Aplicar altera\347\365es ao n\363 selecioando"));
        view.setCancel(makebutton("Cancelar", gridbaglayout, gridbagconstraints, panel1, "N\343o Aplicar altera\347\365es ao n\363 selecioando"));
    }
    
    private Node buildNode( Element element ) {
    	Node node = new Node();
        node.setNome( element.getAttributeValue( "nome" ) );
        node.setId( System.currentTimeMillis()+"_"+element.getAttributeValue( "id" ) );
        node.setFamilia( element.getAttributeValue( "familia" ) );
        
        if(element.getAttributeValue( "cor" ) != null){
        	node.setCor( element.getAttributeValue( "cor" ).toString().replace("#", "") );
        }else{
        	node.setCor( "FFFACD" );
        }
        
        if( element.getAttributeValue( "tipo" ) == null ) {
        	node.setNivel( 0 );
        	node.setTipo( Node.TIPO_ROOT );
        }
        else{
        	node.setTipoNivel( element.getAttributeValue( "tipo" ) );
        }
        return node;
    }
    
    private void buildLeterNodeTree( Node root, List elements ) {
    	
    	Iterator i = elements.iterator();
    	
    	
    	while( i.hasNext() ) {
    		Element child = (Element)i.next();
    		
    		Node node = buildNode( child );
    		
    		buildNodeTree( node, child );
    		
    		node.setTipo( Node.TIPO_TE );
    		
    		root.addNode( node );
    	}
    	
    }
    
    private void buildNodeTree( Node root, Element element ) {
    	
    	Iterator children = element.getChildren().iterator();
    	
    	Node currentNode = root;
    	
    	while( children.hasNext() ) {
    		Element child = (Element)children.next();
    		
    		Node node = buildNode( child );
    		if( currentNode.getNivel() != 0 ) {
    			while( currentNode.getNivel() >= node.getNivel() ) {
	    			if( currentNode.getNivel() == 0 ) {
	    				currentNode = root;
	    			}
	    			else {
	    				currentNode = currentNode.getPai();
	    			}
	    			if( currentNode.equals( root ) ) {
	    				break;
	    			}
	    		}
    		}
    		currentNode.addNode( node );
    		currentNode = node;
    	}
    	
    }
    
    public void init(){
    	pathRoot = null;
        htFile = "";
        
        setPaginaHtml(JSObject.getWindow(this));
        
        //htFile = "aggt.htz";
        if (htHintColor == null)
        	htHintColor = getParameter("hthintcolor");
        
        if (htCenterNode == null)
        	htCenterNode = getParameter("htcenternode");
       
        if (htBackColor == null)
        	htBackColor = getParameter("htbackcolor");
       
        if (htBackColorEdit == null)
        	htBackColorEdit = getParameter("htbackcoloredit");
       
        if (htLinkColor == null)
        	htLinkColor = getParameter("htlinkcolor");
       
        if (htSearchColor == null)
        	htSearchColor = getParameter("htsearchcolor");
       
        if (htBorderType == null)        	
        	htBorderType = getParameter("htbordertype");
       
        if (htFont == null)
        	htFont = getParameter("htfont");
        
        if (htFontSize == null)
        	htFontSize = getParameter("htfontsize");
        
        if (htHomeImage == null)
        	htHomeImage = getParameter("hthomeimage");
       
        if (htConfirmarImage == null)	
        	htConfirmarImage = getParameter("htconfirmarimage");
        
        if (htCancelarImage == null)
        	htCancelarImage = getParameter("htcancelarimage");
        
        if (htAplicarImage == null)
        	htAplicarImage = getParameter("htaplicarimage");
        
        if (htHelpImage == null)
        	htHelpImage = getParameter("hthelpimage");
        
        if (htBackImage == null)
        	htBackImage = getParameter("htbackimage");
        
        if (htHelpFile == null)
        	htHelpFile = getParameter("hthelpfile");
        
        if (htUrlAdr == null)
        	htUrlAdr = getParameter("hturladr");
        /**
         * Parametros criados que devem ser passados atraves do html 
         * responsavel pela chamada do applet
         */
        if (xmlFile == null)
        	xmlFile = getParameter("xmlfile");
        
        if (xmlDiretorio == null)
        	xmlDiretorio = getParameter("xmldiretorio");
        
        if (tipo == null)
        	tipo = getParameter("xmltipo");
        
        if (colorNode == null)
        	colorNode = getParameter("colornode");
        
        if (colorTextNode == null)
        	colorTextNode = getParameter("colortextnode");
        
        if (colorRelationalNode == null)
        	colorRelationalNode = getParameter("colorrelationnode");
        
        if (colorTextRelationNode == null)
        	colorTextRelationNode = getParameter("colortextrelationnode");
        
        funcaoJS = getParameter("funcaoJS");
           
    	/**
         * Modificado por Danilo de Melo Santos
         * Data: 22 de outubro de 2007
         * Objetivo: Montar arvore a partir de um servico, que recebe um arquivo XML formatado
         * no padrao especificado
         */
    	/*
    	 * criacao no no central
    	 */
    	
        //Criamos uma classe SAXBuilder que vai processar o XML4  
        SAXBuilder sb = new SAXBuilder();  
        
        //Este documento agora possui toda a estrutura do arquivo.  
        org.jdom.Document d = null;
		try {
			d = sb.build(new URL(xmlFile));
		} catch (JDOMException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}  
        
        //Recuperamos o elemento root  
        Element mural = d.getRootElement();  
        
        //Recuperamos os elementos filhos (children)  
        List elements = mural.getChildren();  
        Iterator i = elements.iterator();  
        
        Node node = new Node();
        
        node.setId( System.currentTimeMillis()+"" );
        node.setTipo( Node.TIPO_ROOT );
        node.setNivel( 0 );
        
        if (tipo.equals("verbete")) {
//        	Iteramos com os elementos filhos, e filhos do dos filhos  
            Element element = (Element) i.next();
        	node.setId(System.currentTimeMillis()+"_"+element.getAttributeValue( "id" ));
            node.setNome( element.getAttributeValue( "nome" ) );

            buildNodeTree(node, element);
            
    	} else if (tipo.equals("letra")) {
            
    		if (xmlFile.subSequence(xmlFile.length()-3, xmlFile.length()).equals("xml")){
            	node.setNome("PAC");
            	
			} else {
				node.setNome("PAC");
			}
            
    		buildLeterNodeTree( node, elements );
            
    	} else if ( tipo.equals( "alfabeto") ) {
    		node.setNome( "Thesaurus" );
    		// Iteramos com os elementos filhos, e filhos do dos filhos  
            Element element = (Element) i.next();
    		buildNodeTree(node, element);
    	}
        
        //root = new HTFileNode(colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode);
    	
        root = node.buildTree( colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode );
        
        /*
    	 * existem tres possibilidades de geracao da arvore
    	 * verbete, letra ou diretorio
    	 * verbete para termo especifico
    	 * letra para uma letra completa
    	 * e alfabeto quando se desejar carregar o alfabeto de thesaurus numa unica arvore
    	 */
    	/*String s = "_1";
        root.setID(s);
    	if (tipo.equals("verbete")){
            //root.setColor(root.getColor());
            //root.setTextColor(root.getTextColor());
            root.lendoXML(xmlFile);
            root.setName(root.insereRaiz());
            root.setLeafNode(false);
            root.setTopLevel(root);
            root.lendoXMLTERMO(xmlFile);
    	} else if (tipo.equals("letra")){
            //root.setColor(root.getColor());
            //root.setTextColor(root.getTextColor());
            root.lendoXMLLetra(xmlFile);
			if (xmlFile.subSequence(xmlFile.length()-3, xmlFile.length()).equals("xml")){
				root.setName(xmlFile.substring(xmlFile.length()-5, xmlFile.length()-4));
			} else {
				root.setName(xmlFile.substring(xmlFile.length()-1, xmlFile.length()));
			}
            root.setLeafNode(false);
    	} else if (tipo.equals("alfabeto")){
            //root.setColor(root.getColor());
            //root.setTextColor(root.getTextColor());
            root.setName("Thesaurus");
        	String alfabeto[] = {"A" ,"B" ,"C" ,"D" ,"E" ,"F" ,"G" ,"H" ,"I" ,"J" ,"L" ,
    			"M" ,"N" ,"O" ,"P" ,"Q" ,"R" ,"S" ,"T" ,"U" ,"V" ,"X" ,"Z" ,"K" ,
    			"Y" ,"W"};
        	//for (int i = 0; i < alfabeto.length; i++){
        	//	xmlFile = xmlDiretorio.concat(alfabeto[i].concat(".xml"));
	        //    root.insereLetra(alfabeto[i],xmlDiretorio);
        	//}
            root.setLeafNode(false);
    	}*/
		/**
		 * Fim da modificacao inserida no codigo original
		 */
        
        
        if(root == null)
        {
            System.err.println("Erro : N\306o foi poss\241vel iniciar a \240rvore Hiperb\242lica");
            return;
        }
        try
        {	
        	/*GZIPOutputStream gzipoutputstream = new GZIPOutputStream(new FileOutputStream(curDir.concat(htFile).toString()));
            ObjectOutputStream objectoutputstream = new ObjectOutputStream(gzipoutputstream);
            objectoutputstream.writeObject(root);
            gzipoutputstream.close();*/
        }
        catch(Exception exception2)
        {
            System.out.println("\nAGrava de Objetos  :"+exception2.toString());
        }
        hypertree = new HyperTree(root, this);
        view = hypertree.getView();
        view.setApplet(this);
        if(htHintColor != null)
            view.setHintColor(htHintColor);
        if(htBackColor != null)
            view.setBackColor(htBackColor);
        if(htBackColorEdit != null)
        {
            view.setBackColorEdit(htBackColorEdit);
        } else
        {
            htBackColorEdit = "0x222222";
            view.setBackColorEdit(htBackColorEdit);
        }
        if(htLinkColor != null)
            view.setLinkColor(htLinkColor);
        if(htSearchColor != null)
            view.setSearchColor(htSearchColor);
        if(htBorderType != null)
            view.setBorderType(htBorderType);
        if(htCenterNode != null)
            view.setCenterNode(htCenterNode);
        if(htHelpFile != null)
            view.setHelpFile(htHelpFile);
        if(htUrlAdr != null)
            view.setUrlAdr(htUrlAdr);
        if(htFont != null)
            view.setFontNode(htFont);
        else
            view.setFontNode("Serif");
        if(htFontSize != null)
            view.setFontSizeNode((new Integer(htFontSize)).intValue());
        else
            view.setFontSizeNode(12);
        if(htHomeImage != null)
        {
            imageH = getImage(getCodeBase(), htHomeImage);
            if(imageH != null)
                view.setHomeImage(imageH);
        }
        if(htConfirmarImage != null)
        {
            imageO = getImage(getCodeBase(), htConfirmarImage);
            if(imageO != null)
                view.setConfirmarImage(imageO);
        }
        if(htCancelarImage != null)
        {
            imageC = getImage(getCodeBase(), htCancelarImage);
            if(imageC != null)
                view.setCancelarImage(imageC);
        }
        if(htAplicarImage != null)
        {
            imageA = getImage(getCodeBase(), htAplicarImage);
            if(imageA != null)
                view.setAplicarImage(imageA);
        }
        if(htBackImage != null)
        {
            imageB = getImage(getCodeBase(), htBackImage);
            if(imageB != null)
                view.setBackImage(imageB);
        }
        if(htHelpImage != null)
        {
            imageS = getImage(getCodeBase(), htHelpImage);
            if(imageS != null)
                view.setHelpImage(imageS);
        }
        setLayout(new BorderLayout());
        setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
        setSize(new Dimension(800, 600));

        viewFrame = new JFrame(root.getName());
        viewFrame.setContentPane(view);
        viewFrame.setSize(800, 600);
        viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
        makeInterfaceEditor(viewFrame);
        view.setViewFrame(viewFrame);
        makeMenuBar(viewFrame);
        viewFrame.setJMenuBar(menubar);
        viewFrame.setVisible(false);
        
        add(menubar, BorderLayout.NORTH);
        add(view);
        setVisible(true);        
        appletEspelho = this;
    }

    public final void setVisibles()
    {
        viewFrame.setJMenuBar(menubar);
        viewFrame.setVisible(true);
    }

    public final void reLoad(String s)
    {
        hypertree.setNewHyperTree(root, this);
        boolean flag = view.getIsEdited();
        view = null;
        System.gc();
        view = hypertree.getView();
        view.setApplet(this);
        if(htHintColor != null)
            view.setHintColor(htHintColor);
        if(htBackColor != null)
            view.setBackColor(htBackColor);
        if(htLinkColor != null)
            view.setLinkColor(htLinkColor);
        if(htSearchColor != null)
            view.setSearchColor(htSearchColor);
        if(htBorderType != null)
            view.setBorderType(htBorderType);
        if(s != null)
            view.setCenterNode(s);
        if(htHelpFile != null)
            view.setHelpFile(htHelpFile);
        if(htUrlAdr != null)
            view.setUrlAdr(htUrlAdr);
        if(htFont != null)
            view.setFontNode(htFont);
        else
            view.setFontNode("Serif");
        if(htFontSize != null)
            view.setFontSizeNode((new Integer(htFontSize)).intValue());
        else
            view.setFontSizeNode(12);
        if(htHomeImage != null)
        {
            imageH = getImage(getCodeBase(), htHomeImage);
            if(imageH != null)
                view.setHomeImage(imageH);
        }
        if(htConfirmarImage != null)
        {
            imageO = getImage(getCodeBase(), htConfirmarImage);
            if(imageO != null)
                view.setConfirmarImage(imageO);
        }
        if(htCancelarImage != null)
        {
            imageC = getImage(getCodeBase(), htCancelarImage);
            if(imageC != null)
                view.setCancelarImage(imageC);
        }
        if(htAplicarImage != null)
        {
            imageA = getImage(getCodeBase(), htAplicarImage);
            if(imageA != null)
                view.setAplicarImage(imageA);
        }
        if(htBackImage != null)
        {
            imageB = getImage(getCodeBase(), htBackImage);
            if(imageB != null)
                view.setBackImage(imageB);
        }
        if(htHelpImage != null)
        {
            imageS = getImage(getCodeBase(), htHelpImage);
            if(imageS != null)
                view.setHelpImage(imageS);
        }
        setLayout(new BorderLayout());
        setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
        int i = viewFrame.getHeight();
        int j = viewFrame.getWidth();
        int k = viewFrame.getX();
        int l = viewFrame.getY();
        viewFrameOld = viewFrame;
        viewFrame = new JFrame(root.getName());
        viewFrame.setContentPane(view);
        viewFrame.setSize(j, i);
        viewFrame.setLocation(k, l);
        viewFrame.setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));
        makeInterfaceEditor(viewFrame);
        view.setViewFrame(viewFrame);
        makeMenuBar(viewFrame);
        viewFrame.setJMenuBar(menubar);
        viewFrameOld.removeAll();
        viewFrameOld.dispose();
        viewFrame.setVisible(true);
    }

    public void percorre(HTFileNode htfilenode, int i)
    {
        String s = "";
        for(int j = 0; j < i; j++)
            s = s.concat("    ").toString();

        ntNos++;
        for(Enumeration enumeration = htfilenode.children(); enumeration.hasMoreElements();)
        {
            ntNos++;
            HTFileNode htfilenode1 = (HTFileNode)enumeration.nextElement();
            if(!htfilenode1.isLeaf())
            {
                i++;
                percorre(htfilenode1, i);
                i--;
            } else
            {
                i++;
                String s1 = "";
                for(int k = 0; k < i; k++)
                    s1 = s1.concat("    ").toString();

                i--;
            }
        }

    }

    public void stop()
    {
        try
        {
        	/*System.out.println("Grava quando pede pra fechar");
            String s = curDir;
        	//String s = "http://10.1.1.34/ms_tmp/";
            GZIPOutputStream gzipoutputstream = new GZIPOutputStream(new FileOutputStream(s.concat(htFile).toString()));
            ObjectOutputStream objectoutputstream = new ObjectOutputStream(gzipoutputstream);
            objectoutputstream.writeObject(root);
            gzipoutputstream.close();*/
        }
        catch(Exception exception)
        {
            System.out.println("\nBGrava de Objetos  :"+exception.toString());
        }
        destroy();
        percorre(root, 0);
        System.out.println("N. elementos: "+ntNos);
    }

    public void undoRecupera()
    {
        undoControlAtual--;
        if(undoControlAtual < 0)
            if(undoControlBase > 0)
            {
                undoControlAtual = 9;
            } else
            {
                undoControlAtual = 0;
                return;
            }
        try
        {
            /*GZIPInputStream gzipinputstream = new GZIPInputStream((new URL(getCodeBase(), ("undo/").concat(htFile).concat(".").concat(String.valueOf(undoControlAtual).toString())).openStream()));
            ObjectInputStream objectinputstream = new ObjectInputStream(gzipinputstream);
            root = (HTFileNode)objectinputstream.readObject();
            gzipinputstream.close();*/
        }
        catch(Exception exception)
        {
            System.out.println("\nCGrava de Objetos  :"+exception.toString());
        }
    }

    public void undoGrava()
    {
        try
        {
            /*String s = curDir;
            GZIPOutputStream gzipoutputstream = new GZIPOutputStream(new FileOutputStream(s.concat("undo/").concat(htFile).concat(".").concat(String.valueOf(undoControlAtual))));
            ObjectOutputStream objectoutputstream = new ObjectOutputStream(gzipoutputstream);
            objectoutputstream.writeObject(root);
            gzipoutputstream.close();*/
        }
        catch(Exception exception)
        {
            System.out.println("\nDGrava de Objetos  :"+exception.toString());
        }
        undoControlAtual++;
        if(undoControlAtual > 9)
        {
            undoControlBase = 1;
            undoControlAtual = 0;
        }
    }

    public void grava()
    {
        String s = "";
        try
        {
        	/*System.out.println("gravacao");
            s = curDir;
            GZIPOutputStream gzipoutputstream = new GZIPOutputStream(new FileOutputStream(s.concat(htFile).toString()));
            ObjectOutputStream objectoutputstream = new ObjectOutputStream(gzipoutputstream);
            objectoutputstream.writeObject(root);
            gzipoutputstream.close();*/
        }
        catch(Exception exception)
        {
            System.out.println("\nEGrava de Objetos  :"+(exception.toString()).toString());
        }
        System.out.println("Hipertree Gravada em "+(s)+(htFile).toString());
    }

    public boolean hasUndo()
    {
        return undoControlAtual != 0 || undoControlBase != 0;
    }

    public void actionPerformed(ActionEvent actionevent1)
    {
    }

    private static HTFileNode root = null;
    private static HyperTree hypertree = null;
    public static HTView view;
    TextField corField;
    TextField corText;
    TextField hintField;
    TextField urlField;
    TextField textField;
    int ntNos;
    Panel panel;
    Label corLabel;
    Label corTextLabel;
    Label hintLabel;
    Label urlLabel;
    Label textLabel;
    private int undoControlAtual;
    private int undoControlBase;
    private Image imageH;
    private Image imageO;
    private Image imageC;
    private Image imageA;
    private Image imageB;
    private Image imageS;
    JFrame viewFrame;
    JFrame viewFrameOld;
    String htFile;
    String htHintColor;
    String htCenterNode;
    String htBackColor;
    String htBackColorEdit;
    String htLinkColor;
    String htSearchColor;
    String htBorderType;
    String htFont;
    String htFontSize;
    String htHomeImage;
    String htConfirmarImage;
    String htCancelarImage;
    String htAplicarImage;
    String curDir;
    String htHelpImage;
    String htBackImage;
    String htHelpFile;
    String htUrlAdr;
    String xmlFile;
    String xmlDiretorio;
    String pathRoot;
    String tipo;
    String colorNode;
    String colorTextNode;
    String colorRelationalNode;
    String colorTextRelationNode;
    JMenuBar menubar;
    static String funcaoJS;
    static HTApplet appletEspelho;
    private static JSObject paginaHtml;
	
    public static JSObject getPaginaHtml() {
		return paginaHtml;
	}

	public static void setPaginaHtml(JSObject pagina) {
		paginaHtml = pagina;
	}

	public static String getFuncaoJS() {
		return funcaoJS;
	}

	public void setFuncaoJS(String funcao) {
		funcaoJS = funcao;
	}

}